package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLUnionPWAffList_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLUnionPWAffList extends JNIObject  {
	
	/* @generated */
	protected ISLUnionPWAffList(long ptr) {
		/*** PROTECTED REGION ID(ISLUnionPWAffList_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLUnionPWAffList build(long ptr) {
		return new ISLUnionPWAffList(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLUnionPWAffList_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_union_pw_aff_list_alloc 
	 * 
	 * @generated
	**/
	 public static ISLUnionPWAffList build(ISLContext ctx, int n) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_aff_list_alloc) DISABLED START ***/
		ISLUnionPWAffList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionPWAffList.build(ISLNative.isl_union_pw_aff_list_alloc(getNativePtr(ctx), n));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_union_pw_aff_list_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_list_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_union_pw_aff_list_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_list_copy 
	 * 
	 * @generated
	**/
	public ISLUnionPWAffList copy() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_list_copy) DISABLED START ***/
		ISLUnionPWAffList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionPWAffList.build(ISLNative.isl_union_pw_aff_list_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_list_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_list_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_union_pw_aff_list_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_list_n_union_pw_aff 
	 * 
	 * @generated
	**/
	public int getNbUnionPWAffs() {
		/*** PROTECTED REGION ID(isl_union_pw_aff_list_n_union_pw_aff) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_aff_list_n_union_pw_aff(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_list_get_union_pw_aff 
	 * 
	 * @generated
	**/
	public ISLUnionPWAffList get(int index) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_list_get_union_pw_aff) DISABLED START ***/
		ISLUnionPWAffList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionPWAffList.build(ISLNative.isl_union_pw_aff_list_get_union_pw_aff(getNativePtr(this), index));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_list_set_union_pw_aff 
	 * 
	 * @take this pa
	 * @generated
	**/
	public ISLUnionPWAffList set(int index, ISLUnionPWAff pa) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_list_set_union_pw_aff) DISABLED START ***/
		ISLUnionPWAffList res;
		
		synchronized(LOCK) {
			checkParameters(this, pa);
			try {
				res = ISLUnionPWAffList.build(ISLNative.isl_union_pw_aff_list_set_union_pw_aff(getNativePtr(this), index, getNativePtr(pa)));
			} finally {
				taken(this);
				taken(pa);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_list_insert 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLUnionPWAffList insert(int pos, ISLUnionPWAff el) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_list_insert) DISABLED START ***/
		ISLUnionPWAffList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLUnionPWAffList.build(ISLNative.isl_union_pw_aff_list_insert(getNativePtr(this), pos, getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_list_add 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLUnionPWAffList add(ISLUnionPWAff el) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_list_add) DISABLED START ***/
		ISLUnionPWAffList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLUnionPWAffList.build(ISLNative.isl_union_pw_aff_list_add(getNativePtr(this), getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_list_drop 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWAffList drop(int first, int n) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_list_drop) DISABLED START ***/
		ISLUnionPWAffList res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWAffList.build(ISLNative.isl_union_pw_aff_list_drop(getNativePtr(this), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_aff_list_concat 
	 * 
	 * @take this list2
	 * @generated
	**/
	public ISLUnionPWAffList concat(ISLUnionPWAffList list2) {
		/*** PROTECTED REGION ID(isl_union_pw_aff_list_concat) DISABLED START ***/
		ISLUnionPWAffList res;
		
		synchronized(LOCK) {
			checkParameters(this, list2);
			try {
				res = ISLUnionPWAffList.build(ISLNative.isl_union_pw_aff_list_concat(getNativePtr(this), getNativePtr(list2)));
			} finally {
				taken(this);
				taken(list2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLUnionPWAffList_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
